/**
 * Basic sample plugin inserting current date and time into CKEditor editing area.
 */

// Register the plugin with the editor.
// http://docs.cksource.com/ckeditor_api/symbols/CKEDITOR.plugins.html
var tabcount=0;

CKEDITOR.plugins.add( 'accordion',
{
	// The plugin initialization logic goes inside this method.
	// http://docs.cksource.com/ckeditor_api/symbols/CKEDITOR.pluginDefinition.html#init
	init: function( editor )
	{editor.addCss( '.accordion{border:#FF3300 dotted 1px; }.Panel{ border:#ccc solid 3px;}.AccordionPanelTab {background:#ccc; border:#000 dotted 1px;margin-top:0p' );
		
		// Define an editor command that inserts a timestamp. 
		// http://docs.cksource.com/ckeditor_api/symbols/CKEDITOR.editor.html#addCommand
		editor.addCommand( 'insertAccordion',
			{
				// Define a function that will be fired when the command is executed.
				// http://docs.cksource.com/ckeditor_api/symbols/CKEDITOR.commandDefinition.html#exec
				exec : function( editor )
				{    
				editor.insertHtml( '<div class="accordion" id="accordion"><div class="Panel"><div class="AccordionPanelTab">Title1 </div><div class="AccordionPanelContent">Content 1</div></div><br><div class="Panel"><div class="AccordionPanelTab">Title2 </div><div class="AccordionPanelContent">Content 2</div></div> <br> <br> </div>' );
				tabcount=3;
				}
			});
		// Create a toolbar button that executes the plugin command. 
		// http://docs.cksource.com/ckeditor_api/symbols/CKEDITOR.ui.html#addButton
		editor.ui.addButton( 'Accordion',
		{
			// Toolbar button tooltip.
			label: 'Insert Accordion',
			// Reference to the plugin command name.
			command: 'insertAccordion',
			// Button's icon file path.
			icon: this.path + 'images/accordion.png'
		} );
		
		
		editor.addCommand( 'insertNewTab',
			{
				// Define a function that will be fired when the command is executed.
				// http://docs.cksource.com/ckeditor_api/symbols/CKEDITOR.commandDefinition.html#exec
				exec : function( editor )
				{    
				// Insert the timestamp into the document.
					// http://docs.cksource.com/ckeditor_api/symbols/CKEDITOR.editor.html#insertHtml
				editor.insertHtml( '<div class="Panel"><div class="AccordionPanelTab">Title '+tabcount+'</div><div class="AccordionPanelContent">Content '+tabcount+'</div></div><br>' );
					tabcount++;
				}
			});
		// Create a toolbar button that executes the plugin command. 
		// http://docs.cksource.com/ckeditor_api/symbols/CKEDITOR.ui.html#addButton
		editor.ui.addButton( 'NewTab',
		{
			// Toolbar button tooltip.
			label: 'Insert New Tab',
			// Reference to the plugin command name.
			command: 'insertNewTab',
			disabled: 'disabled',
			// Button's icon file path.
			icon: this.path + 'images/tab_new.png'
		} );
	}
} );